
Redmine - Defect #32754

Fix missing arrow icon of collapse macro

2020-01-05 09:08 - Popoki Tom (@cat_in_136)

Status: Closed Start date:  

Priority: Normal Due date:  

Assignee: Go MAEDA % Done: 0%

Category: Text formatting Estimated time: 0.00 hour

Target version: 4.1.1   

Resolution: Fixed Affected version: 4.1.0

Description

When {{collapse}} macro used in the wiki text, a small arrow icon should be displayed but actually is not displayed on redmine 4.1.0.

Steps to reproduce the issue

Just use {{collapse}} macro in the wiki text. For example,

{{collapse 

foobar 

}}

 Arrow icon should be displayed. You can see right behavior here (because redmine.org does not use redmine 4.1.):

ShowHide

foobar

Causes

This is obviously a degrade due to #31433. r18204 removes arrow icons from .collapsible.

Workaround

Add following CSS rules.

.wiki a.collapsible {padding-left: 12px; background: url(../images/arrow_down.png) no-repeat 0px 

50%;}

.wiki a.collapsible.collapsed {background-image: url(../images/arrow_right.png);}

 Note that: The icon path should be change to the absolute path if you add the snippet to your theme or the view_customize rule.

.wiki a.collapsible {padding-left: 12px; background: url(/images/arrow_down.png) no-repeat 0px 50%

;}

.wiki a.collapsible.collapsed {background-image: url(/images/arrow_right.png);}

Associated revisions

Revision 19409 - 2020-01-07 02:34 - Go MAEDA

Fix that arrow icon for {{collapse}} macro is not shown (#32754).

Patch by Marius BALTEANU.

Revision 19410 - 2020-01-07 02:51 - Go MAEDA

Reverts r19409 that breaks some tests (#32754).

Revision 19413 - 2020-01-07 15:56 - Go MAEDA

Fix missing arrow icon of collapse macro (#32754).
Patch by Marius BALTEANU.

Revision 19424 - 2020-01-13 01:39 - Go MAEDA

Merged r19413 from trunk to 4.1-stable (#32754).

History

#1 - 2020-01-05 10:25 - Marius BĂLTEANU

- Assignee set to Marius BĂLTEANU

- Target version set to 4.1.1

#2 - 2020-01-05 11:35 - Marius BĂLTEANU

- Status changed from New to Confirmed

- Assignee changed from Marius BĂLTEANU to Go MAEDA

The below changes fix the problem:

mariusbalteanu@Mariuss-MacBook-Pro redmine % git diff

diff --git a/lib/redmine/wiki_formatting/macros.rb b/lib/redmine/wiki_formatting/macros.rb

index 53276834f..0e1e4234c 100644

--- a/lib/redmine/wiki_formatting/macros.rb

+++ b/lib/redmine/wiki_formatting/macros.rb

@@ -234,8 +234,8 @@ module Redmine

         hide_label = args[1] || args[0] || l(:button_hide)

         js = "$('##{html_id}-show, ##{html_id}-hide').toggle(); $('##{html_id}').fadeToggle(150);" 

         out = ''.html_safe

-        out << link_to_function(show_label, js, :id => "#{html_id}-show", :class => 'collapsible collapsed')

-        out << link_to_function(hide_label, js, :id => "#{html_id}-hide", :class => 'collapsible', :style => 

'display:none;')

+        out << link_to_function(show_label, js, :id => "#{html_id}-show", :class => 'icon icon-collapsed coll

apsible')

+        out << link_to_function(hide_label, js, :id => "#{html_id}-hide", :class => 'icon icon-expended colla

psible', :style => 'display:none;')

         out << content_tag('div', textilizable(text, :object => obj, :headings => false, :inline_attachments 

=> @@inline_attachments), :id => html_id, :class => 'collapsed-text', :style => 'display:none;')

         out

       end

 Thanks @Popoki Tom for reporting the issue.

#3 - 2020-01-05 16:13 - Popoki Tom (@cat_in_136)

I've confirmed that the patch written in #32754#note-2 fixes this issue.

Thank you.

#4 - 2020-01-07 03:18 - Go MAEDA

Thank you for posting the patch #32754#note-2 but it breaks some tests.

 bin/rails test test/unit/lib/redmine/wiki_formatting/macros_test.rb

Run options: --seed 46106

# Running:

.........F

Failure:

Redmine::WikiFormatting::MacrosTest#test_macro_collapse_with_one_arg [/Users/maeda/redmines/redmine-trunk/test

/unit/lib/redmine/wiki_formatting/macros_test.rb:229]:

Expected at least 1 element matching "a.collapsible.collapsed", found 0..

Expected 0 to be >= 1.

bin/rails test test/unit/lib/redmine/wiki_formatting/macros_test.rb:223

....F

Failure:

Redmine::WikiFormatting::MacrosTest#test_macro_collapse_with_two_args [/Users/maeda/redmines/redmine-trunk/tes

t/unit/lib/redmine/wiki_formatting/macros_test.rb:239]:

Expected at least 1 element matching "a.collapsible.collapsed", found 0..

Expected 0 to be >= 1.
bin/rails test test/unit/lib/redmine/wiki_formatting/macros_test.rb:233

................F

Failure:

Redmine::WikiFormatting::MacrosTest#test_macro_collapse [/Users/maeda/redmines/redmine-trunk/test/unit/lib/red

mine/wiki_formatting/macros_test.rb:218]:

Expected at least 1 element matching "a.collapsible.collapsed", found 0..

Expected 0 to be >= 1.

bin/rails test test/unit/lib/redmine/wiki_formatting/macros_test.rb:211

.............

Finished in 4.373005s, 10.2904 runs/s, 16.2360 assertions/s.

45 runs, 71 assertions, 3 failures, 0 errors, 0 skips

#5 - 2020-01-07 15:02 - Go MAEDA

- File 32754-update-test.patch added

Go MAEDA wrote:

Thank you for posting the patch #32754#note-2 but it breaks some tests.

[...]

 It can be fixed by applying 32754-update-test.patch.

#6 - 2020-01-07 15:08 - Marius BĂLTEANU

- File 0001-Fix-missing-arrow-icon-of-collapse.patch added

Go MAEDA wrote:

Go MAEDA wrote:

Thank you for posting the patch #32754#note-2 but it breaks some tests.

[...]

 It can be fixed by applying 32754-update-test.patch.

 Please use this one, all tests pass: https://gitlab.com/redmine-org/redmine/pipelines/107443098

#7 - 2020-01-07 15:57 - Go MAEDA

- Subject changed from the arrow icon of {{collapse}} not shown on redmine 4.1.0. to Fix missing arrow icon of collapse macro

- Category changed from Wiki to Text formatting

- Status changed from Confirmed to Closed

- Resolution set to Fixed

Committed the patch. Thank you for detecting and fixing the issue.

#8 - 2020-01-12 12:26 - Michael Gerz

Go MAEDA wrote:

Committed the patch. Thank you for detecting and fixing the issue.

 I think it hasn’t been backported, yet.

#9 - 2020-01-12 13:23 - Go MAEDA

- Status changed from Closed to Reopened
#10 - 2020-01-13 01:40 - Go MAEDA

- Status changed from Reopened to Closed

Michael Gerz wrote:

I think it hasn’t been backported, yet.

 You are right, thank you for pointing it out. I have just merged the change to 4.1-stable in r19424.

Files

32754-update-test.patch 1.55 KB 2020-01-07 Go MAEDA

0001-Fix-missing-arrow-icon-of-collapse.patch 3.24 KB 2020-01-07 Marius BĂLTEANU
